public inbox for fstests@vger.kernel.org
 help / color / mirror / Atom feed
From: Xiong Zhou <xzhou@redhat.com>
To: fstests@vger.kernel.org
Cc: ross.zwisler@linux.intel.com, dan.j.williams@intel.com,
	jmoyer@redhat.com, eguan@redhat.com,
	Xiong Zhou <xzhou@redhat.com>
Subject: [PATCH v3 3/4] xfs: test per-inode DAX flag DAX to non-DAX
Date: Wed, 12 Apr 2017 22:46:19 +0800	[thread overview]
Message-ID: <1492008380-29164-4-git-send-email-xzhou@redhat.com> (raw)
In-Reply-To: <1492008380-29164-1-git-send-email-xzhou@redhat.com>

This test is split from xfs/260, only do IO from DAX
to non-DAX.

Since DIO from DAX to non-DAX is only supported/doable
when device underneath has memory(struct page) backend.

By ndctl looking at SCRATCH_DEV, skip this test if it is
not in "memory mode".

Signed-off-by: Xiong Zhou <xzhou@redhat.com>
---
 tests/xfs/288     | 111 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/288.out |   2 +
 tests/xfs/group   |   1 +
 3 files changed, 114 insertions(+)
 create mode 100755 tests/xfs/288
 create mode 100644 tests/xfs/288.out

diff --git a/tests/xfs/288 b/tests/xfs/288
new file mode 100755
index 0000000..d296a36
--- /dev/null
+++ b/tests/xfs/288
@@ -0,0 +1,111 @@
+#! /bin/bash
+# FS QA Test 288
+#
+# Test per-inode DAX flag by mmap direct/buffered IO.
+# Split from xfs/260, only do the DAX to non-DAX part.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Red Hat Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+_supported_fs xfs
+_supported_os Linux
+_require_scratch_dax
+_require_test_program "feature"
+_require_test_program "t_mmap_dio"
+_require_xfs_io_command "chattr" "+/-x"
+_require_xfs_io_command "falloc"
+_require_pmem_key_value $SCRATCH_DEV "mode" "memory"
+
+prep_files()
+{
+	rm -f $SCRATCH_MNT/tf_{s,d}
+
+	$XFS_IO_PROG -f -c "falloc 0 $tsize" \
+		$SCRATCH_MNT/tf_{s,d} >> $seqres.full 2>&1
+}
+
+t_dax_to_nondax()
+{
+	prep_files
+	$XFS_IO_PROG -c "chattr +x" $SCRATCH_MNT/tf_s
+	$XFS_IO_PROG -c "chattr -x" $SCRATCH_MNT/tf_d
+	src/t_mmap_dio $SCRATCH_MNT/tf_{s,d} \
+		$1 "dio dax to nondax"
+
+	prep_files
+	$XFS_IO_PROG -c "chattr +x" $SCRATCH_MNT/tf_s
+	$XFS_IO_PROG -c "chattr -x" $SCRATCH_MNT/tf_d
+	src/t_mmap_dio -b $SCRATCH_MNT/tf_{s,d} \
+		$1 "buffered dax to nondax"
+}
+
+do_tests()
+{
+	# less than page size
+	t_dax_to_nondax 1024
+	# page size
+	t_dax_to_nondax `src/feature -s`
+	# bigger sizes, for PMD faults
+	t_dax_to_nondax $((16 * 1024 * 1024))
+	t_dax_to_nondax $((64 * 1024 * 1024))
+}
+
+# make xfs 2Mb aligned for PMD fault testing
+_scratch_mkfs "-d su=2m,sw=1" > /dev/null 2>&1
+
+# mount with dax option
+_scratch_mount "-o dax"
+
+tsize=$((128 * 1024 * 1024))
+
+do_tests
+_scratch_unmount
+_check_scratch_fs
+
+# mount again without dax option
+export MOUNT_OPTIONS=""
+export TEST_FS_MOUNT_OPTS=""
+_scratch_mount
+do_tests
+
+# success, all done
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/xfs/288.out b/tests/xfs/288.out
new file mode 100644
index 0000000..2958a5c
--- /dev/null
+++ b/tests/xfs/288.out
@@ -0,0 +1,2 @@
+QA output created by 288
+Silence is golden
diff --git a/tests/xfs/group b/tests/xfs/group
index 75769f9..736de3c 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -285,6 +285,7 @@
 285 dangerous_fuzzers dangerous_scrub
 286 dangerous_fuzzers dangerous_scrub dangerous_online_repair
 287 auto dump quota quick
+288 auto quick
 290 auto rw prealloc quick ioctl zero
 291 auto repair
 292 auto mkfs quick
-- 
1.8.3.1


  parent reply	other threads:[~2017-04-12 14:46 UTC|newest]

Thread overview: 71+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-04-07  7:56 [PATCH 1/3] common: helper to get value from ndctl list by key Xiong Zhou
2017-04-07  7:56 ` [PATCH 2/3] DAX-DIO: skip DAX to non-DAX if unsupported Xiong Zhou
2017-04-12  3:30   ` Ross Zwisler
2017-04-07  7:56 ` [PATCH 3/3] DAX: mmap write readonly file Xiong Zhou
2017-04-07 17:16 ` [PATCH 1/3] common: helper to get value from ndctl list by key Ross Zwisler
2017-04-10  6:05   ` [PATCH v2 " Xiong Zhou
2017-04-10  6:05     ` [PATCH v2 2/3] DAX-DIO: skip DAX to non-DAX if unsupported Xiong Zhou
2017-04-11 11:44       ` Eryu Guan
2017-04-11 13:54         ` Jeff Moyer
2017-04-11 14:26         ` Xiong Zhou
2017-04-10  6:05     ` [PATCH v2 3/3] DAX: mmap write readonly file Xiong Zhou
2017-04-11 11:46       ` Eryu Guan
2017-04-11 13:56         ` Jeff Moyer
2017-04-11 18:52           ` Ross Zwisler
2017-04-11 22:45             ` Ross Zwisler
2017-04-12  2:52               ` Xiong Zhou
2017-04-12  4:03       ` Ross Zwisler
2017-04-12  6:26         ` Xiong Zhou
2017-04-12 14:46           ` [PATCH v3 0/4] split DAX mmap DIO cases Xiong Zhou
2017-04-12 14:46             ` [PATCH v3 1/4] DAX-DIO: make dax_to_non_dax dio test solo Xiong Zhou
2017-04-12 14:46             ` [PATCH v3 2/4] generic: test mmap io fom DAX to non-DAX Xiong Zhou
2017-04-13  4:11               ` Xiong Zhou
2017-04-13 13:36                 ` Dan Williams
2017-04-14 10:01                   ` Xiong Zhou
2017-04-14 14:49                     ` Dan Williams
2017-04-14 15:22                       ` Ross Zwisler
2017-04-14 15:33                         ` Dan Williams
2017-04-14 15:51                           ` Ross Zwisler
2017-04-12 14:46             ` Xiong Zhou [this message]
2017-04-12 14:46             ` [PATCH v3 4/4] generic: mmap write readonly DAX file Xiong Zhou
2017-04-17  7:14             ` [PATCH v4 0/4] split DAX mmap DIO cases Xiong Zhou
2017-04-17  7:14               ` [PATCH v4 1/4] DAX-DIO: make dax_to_non_dax dio test solo Xiong Zhou
2017-04-18 16:31                 ` Ross Zwisler
2017-04-17  7:14               ` [PATCH v4 2/4] generic: test mmap io fom DAX to non-DAX Xiong Zhou
2017-04-17 14:14                 ` Dan Williams
2017-04-17 22:54                   ` Dan Williams
2017-04-17 23:39                     ` Ross Zwisler
2017-04-17 23:47                       ` Dan Williams
2017-04-19  8:40                   ` Xiong Zhou
2017-04-19 15:53                     ` Dan Williams
2017-04-18 10:12                 ` Christoph Hellwig
2017-04-18 14:49                   ` Xiong Zhou
2017-07-28 14:55                   ` Jeff Moyer
2017-04-18 16:32                 ` Ross Zwisler
2017-04-17  7:14               ` [PATCH v4 3/4] xfs: test per-inode DAX flag " Xiong Zhou
2017-04-18 16:36                 ` Ross Zwisler
2017-04-17  7:14               ` [PATCH v4 4/4] generic: mmap write readonly DAX file Xiong Zhou
2017-04-18 17:05                 ` Ross Zwisler
2017-04-19  2:54                   ` Xiong Zhou
2017-04-24 16:34                 ` Ross Zwisler
2017-09-25  8:40               ` [PATCH v5 0/3] fix dax to nondax dio fake failures Xiong Zhou
2017-09-25  8:40                 ` [PATCH v5 1/3] generic: mmap write readonly DAX file Xiong Zhou
2017-09-27  9:57                   ` Eryu Guan
2017-09-25  8:40                 ` [PATCH v5 2/3] generic/413: skip dax to nondax dio test if needed Xiong Zhou
2017-09-27  9:50                   ` Eryu Guan
2017-09-27 15:01                     ` Jeff Moyer
2017-09-25  8:40                 ` [PATCH v5 3/3] xfs/260: remove per-inode DAX flag test Xiong Zhou
2017-09-25 16:59                   ` Ross Zwisler
2017-09-26  0:51                     ` Xiong Zhou
2017-09-28  7:41                 ` [PATCH v6 0/4] fix dax to nondax dio fake failures Xiong Zhou
2017-09-28  7:41                   ` [PATCH v6 1/4] tests: add new group dax Xiong Zhou
2017-09-28  7:41                   ` [PATCH v6 2/4] gitignore: sort src/ binaries name Xiong Zhou
2017-09-28 11:10                     ` Dave Chinner
2017-09-28 12:28                       ` Xiong Zhou
2017-09-28 21:43                         ` Dave Chinner
2017-09-28  7:41                   ` [PATCH v6 3/4] generic: mmap write readonly DAX file Xiong Zhou
2017-09-28  7:41                   ` [PATCH v6 4/4] generic/413: skip dax to nondax dio test if needed Xiong Zhou
2017-09-29  2:16                   ` [PATCH v7] " Xiong Zhou
2017-09-29 16:24                     ` Ross Zwisler
2017-09-30  2:30                       ` Xiong Zhou
2017-04-11 11:40     ` [PATCH v2 1/3] common: helper to get value from ndctl list by key Eryu Guan

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1492008380-29164-4-git-send-email-xzhou@redhat.com \
    --to=xzhou@redhat.com \
    --cc=dan.j.williams@intel.com \
    --cc=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    --cc=jmoyer@redhat.com \
    --cc=ross.zwisler@linux.intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox